SuperStrict
AppTitle="BCC48"
Graphics 800,640
SeedRnd MilliSecs()

Global fieldgfx:TImage=LoadImage("gfx/field.jpg"),blockgfx:TImage=LoadImage("gfx/block.png"),foodgfx:TImage=LoadImage("gfx/food.png"),tailgfx:TImage=LoadImage("gfx/tail.png"),block0gfx:TImage=LoadImage("gfx/block0.png"),failgfx:TImage=LoadImage("gfx/fail.png"),menu0gfx:TImage=LoadImage("gfx/menu0.png"),menu1gfx:TImage=LoadImage("gfx/menu1.png")
Global bite:TSound=LoadSound("msx/bite.wav"),pling:TSound=LoadSound("msx/pling.wav")
Global timer:TTimer=CreateTimer(40)
Global Schr:TImagefont = LoadImageFont("res/Gilgond.ttf" , 30) ; SetImageFont Schr
Global TPlayer:Player=New Player
Global menu:Int,game:Int[40,30],numbtails:Int,maxtails:Int=3,fx:Int,fy:Int
Global t:Int,t2:Int,t3:Int,t4:Int,t5:Int 'Fuer Abzaehlen der Zeit in Hauptschleife
Global xbl:Int=0,ybl:Int=1,dbl:Int 'Fuer erstellen der neuen Bloecke
Global opt:Float[10] 'Optionen Einstellungen
Global spec:Int[5,3] 'Fuer das Obst

Repeat
	Select menu
		Case 0
			DrawImage menu0gfx,0,0
			DrawText "Start Game" , 120 , 380
			DrawText "Options" , 360 , 380
			If KeyHit(Key_Right) menu = 1 
			If KeyHit(Key_Up) menu = 2
		Case 1
			DrawImage menu1gfx,0,0
			DrawText "Use the Arrow-Keys to move!" , 100 , 100
			DrawText "Try not to collide with the walls!" , 100 , 130
			DrawText "Try to collect everything u can reach!" , 100 , 160
			
			DrawText "Speed Player",160,230
			For opt[7]=0 To opt[1]
				DrawImage tailgfx,390+(opt[7]*20),250
			Next
			DrawText "Speed Blocks",160,260
			For opt[7]=0 To opt[2]
				DrawImage blockgfx,390+(opt[7]*20),265
			Next
			DrawText "Food",160,290
			For opt[7]=0 To opt[3]
				DrawImage foodgfx,390+(opt[7]*20),305
			Next

			DrawImage TPlayer.Playergfx,130,240+(opt[0]*30)
			
			DrawText "Main Menu" , 80 , 560
			
			If KeyHit(Key_Left) menu = 0
			If KeyHit(Key_Down) Then 
				If opt[0]<2 opt[0]:+1 
			EndIf
			If KeyHit(Key_Up) Then 
				If opt[0]>0 opt[0]:-1 
			EndIf
			If KeyDown(Key_Right) Then
				If opt[0]=0 Then
					opt[1]:+1
					If opt[1]>2 opt[1]=0
				EndIf
				If opt[0]=1 Then
					opt[2]:+1
					If opt[2]>2 opt[2]=0
				EndIf
				If opt[0]=2 Then
					opt[3]:+1
					If opt[3]>2 opt[3]=0
				EndIf
			EndIf 
		Case 2
			DrawMap(1)
			
			If t3=0 Then
				t=MilliSecs()+400
				t3=1
			EndIf
			
			If t<MilliSecs() Then
				t3=0
				t4:+1
				t5:+1
				Tail.Create(TPlayer.X,TPlayer.Y)
				numbtails:+1
				If t4>0 Then 
					For opt[7]=0 To opt[2]
						MultiplyBlocks()
					Next
					t4=0
				EndIf
				If t5>5 Then 
				For opt[7]=0 To opt[3]
					fx=Rand(1,39)
					fy=Rand(3,29)
					If game[fx,fy]=0
						Food.Create(fx,fy)
					EndIf
					t5=0
				Next
				EndIf 
			EndIf 

			Food.UpdateAll()

			Specials(0)
			Specials(1)
			Specials(2)
			Specials(3)
			Specials(4)
			
			Tail.UpdateAll()
			
			TPlayer.DaM
			TPlayer.Pts
		
			DrawMap(2)
		Case 3
			DrawMap(1)
			DrawMap(2)
			TPlayer.Pts
			DrawImage failgfx,100,120
	End Select
	FlushKeys()
	WaitTimer(timer)
	Flip;Cls
Until KeyHit(Key_Escape) Or AppTerminate()

Function DrawMap(c:Int)
	Local a:Int , b:Int
	game[14,5]=2;game[10,11]=2;game[20,10]=2;game[30,9]=2;game[15,20]=2;game[25,20]=2
	For a = 0 To 39
		For b = 0 To 29
			Select c
				Case 1
					DrawImage fieldgfx , a * 20 , b * 20 + 40
				Case 2
					If a = 0 Or b = 0 Or a = 39 Or b = 29 Then game[a,b] = 1
					Select game[a , b]
						Case 1
							DrawImage blockgfx, a * 20 + 1, b * 20 + 30
						Case 2
							DrawImage block0gfx, a * 20 + 1, b * 20 + 30
					End Select 
			End Select 
		Next
	Next
End Function

Function MultiplyBlocks()			
	Select dbl
		Case 0
			If game[xbl + 1 , ybl] <> 1 Then
				xbl:+ 1
				game[xbl,ybl]=1
			Else
				dbl = 1
			EndIf 
		Case 1
			If game[xbl , ybl+1] <> 1 Then
				ybl:+ 1
				game[xbl,ybl]=1
			Else
				dbl=2
			EndIf 
		Case 2
			If game[xbl - 1 , ybl] <> 1 Then
				xbl:- 1
				game[xbl,ybl]=1
			Else
				dbl =3
			EndIf
		Case 3
			If game[xbl , ybl-1] <> 1 Then
				ybl:- 1
				game[xbl,ybl]=1
			Else
				dbl=0
			EndIf
	End Select 
End Function

Function Specials(no:Int)
	Local sgfx0:TImage = LoadImage("gfx/cherries.png"),sgfx1:TImage = LoadImage("gfx/banana.png"),sgfx2:TImage = LoadImage("gfx/apple.png"),sgfx3:TImage = LoadImage("gfx/pineapple.png")
	If spec[no , 0] = 0 Then
		spec[no , 1] = Rand(0 , 39) 'X
		spec[no , 2] = Rand(2 , 29) 'Y
	EndIf 
	If game[spec[no , 1] , (spec[no , 2])-2] = 0 Then 
		spec[no,0]=1
	Else
		spec[no,0]=0
	EndIf
	If spec[no,0]=1 Then 
		Select no
			Case 0
				DrawImage sgfx1 , spec[no , 1] * 20 , spec[no , 2] * 20
				If ImagesCollide(sgfx1 , spec[no , 1] * 20 , spec[no , 2] * 20 , 0 , TPlayer.playergfx , TPlayer.X , TPlayer.Y , 0) Then
					spec[no , 0] = 0
					PlaySound bite
					TPlayer.points:+ 20
				EndIf
			Case 1
				DrawImage sgfx1 , spec[no,1]*20 , spec[no,2]*20 
				If ImagesCollide(sgfx1 , spec[no , 1] * 20 , spec[no , 2] * 20 , 0 , TPlayer.playergfx , TPlayer.X , TPlayer.Y , 0) Then
					spec[no , 0] = 0
					PlaySound bite
					TPlayer.points:+ 20
				EndIf
			Case 2
				DrawImage sgfx2 , spec[no,1]*20 , spec[no,2]*20
				If ImagesCollide(sgfx1,spec[no , 1] * 20 , spec[no , 2] * 20,0,TPlayer.playergfx,TPlayer.X,TPlayer.Y,0) Then
					spec[no , 0] = 0
					PlaySound bite
					TPlayer.points:+ 20
				EndIf
			Case 3
				DrawImage sgfx3 , spec[no,1]*20 , spec[no,2]*20
				If ImagesCollide(sgfx1,spec[no , 1] * 20 , spec[no , 2] * 20,0,TPlayer.playergfx,TPlayer.X,TPlayer.Y,0) Then
					spec[no , 0] = 0
					PlaySound bite
					TPlayer.points:+ 20
				EndIf
			Case 4
				DrawImage sgfx0 , spec[no,1]*20 , spec[no,2]*20
				If ImagesCollide(sgfx1,spec[no , 1] * 20 , spec[no , 2] * 20,0,TPlayer.playergfx,TPlayer.X,TPlayer.Y,0) Then 
					spec[no , 0] = 0
					PlaySound bite
					TPlayer.points:+ 20
				EndIf
		End Select
	EndIf

EndFunction

Type Player
	Field X:Float=240,Y:Float=160,movx:Float=1,movy:Float=0,points:Int,playergfx:TImage=LoadImage("gfx/player0.png")
	Method DaM()
		DrawImage playergfx , X , Y
		X:+movx
		Y:+movy
		'----------Move
		If movx<1 And KeyDown(Key_Left) Then 
			movx = - ((opt[1]*0.25)+1)
			movy = 0
		EndIf
		If movx>-1 And KeyDown(Key_Right) Then
			movx = ((opt[1]*0.25)+1)
			movy=0
		EndIf 
		If movy<1 And KeyDown(Key_Up) Then 
			movx = 0
			movy=-((opt[1]*0.25)+1)
		EndIf 
		If movy>-1 And KeyDown(Key_Down) Then
			movx = 0
			movy = ((opt[1]*0.25)+1)
		EndIf
		'----------Collision
		If game[(X+2)/20 , (Y-38)/20] > 0 Or game[(X+14)/20 , (Y-38)/20] > 0 Or game[(X+2)/20 , (Y-26)/20] > 0 Or game[(X+14)/20 , (Y-26)/20] > 0 Then 'Y immer -40, da map um 40 nach Y+ verschoben ist
			movx = 0
			movy = 0
			menu=3
		EndIf
	End Method
	Method Pts()
		DrawText points,340,-5
	End Method
End Type

Type Tail
	Field X:Int,Y:Int,Xt:Float,Yt:Float,Age:Float
	Field tailgfx:TImage=LoadImage("gfx/tail.png")
	Global TailList:TList
	
	Function Create(X:Int,Y:Int)
		Local NewTail:Tail = New Tail
			NewTail.X = X
			NewTail.Y = Y
			NewTail.Age = 0.2
			
		If Not TailList Then TailList = CreateList()
		TailList.addlast(NewTail)
	End Function
	
	Function UpdateAll()
		If Not TailList Return
		For Local Tails:Tail = EachIn TailList
			SetScale(Tails.Age , Tails.Age)
			Tails.Xt = (16-(Tails.Age*12))/2
			Tails.Yt = (16-(Tails.Age*12))/2
			DrawImage Tails.tailgfx,Tails.X+Tails.Xt,Tails.Y+Tails.Yt
			Tails.Age:+0.03
			If Tails.Age>1 Tails.Age=1
			If numbtails>maxtails Then 
				TailList.removefirst()
				numbtails:-1
			EndIf 
			SetScale(1,1)
			If Tails.Age=1 And ImagesCollide(TPlayer.playergfx,TPlayer.X,TPlayer.Y,0,Tails.tailgfx,Tails.X,Tails.Y,0) Then 
				menu=3
			EndIf 
		Next
	End Function
End Type

Type Food
	Field X:Int,Y:Int,Foodgfx:TImage=LoadImage("gfx/food.png")
	Global FoodList:TList
	
	Function Create(x:Int,y:Int)
		Local NewFood:Food=New Food
		If Not FoodList Then FoodList=CreateList()
			NewFood.X=x*20+5
			NewFood.Y=y*20+5
		FoodList.Addlast(NewFood)
	End Function
	
	Function UpdateAll()
		If Not FoodList Return
		For Local Foods:Food=EachIn FoodList
			DrawImage Foods.Foodgfx,Foods.x,Foods.y
			If ImagesCollide(Foods.Foodgfx,Foods.x,Foods.y,0,TPlayer.playergfx,TPlayer.X,TPlayer.Y,0) Then
				'game[Foods.x/20,Foods.y/20]=0
				Foodlist.remove(Foods)
				PlaySound pling
				TPlayer.points:+40
				maxtails:+1
			EndIf 
		Next
	End Function
End Type